<?php error_reporting(E_ALL);

$dir = __DIR__ . '/../spec/';
$tocFile = $dir . '00-specification-for-hack.md';
$prefix = <<<EOS
<!-- This file is autogenerated, do not edit it manually -->
<!-- Run tools/toc.php instead -->

<style type = "text/css">
  header {
    border-color: red;
    border-width: .25em;
    border-style: solid;
    padding: .25em;
  }
</style>
<header>
NOTICE: This spec is currently very out of date and does not reflect the current version of Hack.
</header>

# Specification for Hack
Facebook has dedicated all copyright to this specification to the public
domain worldwide under the CC0 Public Domain Dedication located at
<http://creativecommons.org/publicdomain/zero/1.0/>. This specification
is distributed without any warranty.

(Initially written by Facebook, Inc., February 2015)

**Table of Contents**
EOS;

$files = scandir($dir);
$output = "";

foreach ($files as $file) {
    if ($file == '00-specification-for-hack.md' || $file == 'hack-spec-draft.md') {
        continue;
    }

    $anchors = [];

    $lines = file($dir . $file);
    foreach ($lines as $line) {
        if (!preg_match('/^(#+)\s*(.+)/', $line, $matches)) {
            continue;
        }

        list(, $hashes, $title) = $matches;
        $level = strlen($hashes) - 1;
        $indent = str_repeat('  ', $level);

        $anchor = strtr(strtolower($title), ' ', '-');
        $anchor = preg_replace('/[^\w-]/', '', $anchor);

        if (isset($anchors[$anchor])) {
            $anchors[$anchor]++;
            $anchor .= '-' . $anchors[$anchor];
        } else {
            $anchors[$anchor] = 0;
        }

        $output .= "$indent- [$title]($file#$anchor)\n";
    }
}

file_put_contents($tocFile, "$prefix\n$output");
